(define (create-sprite-sheet img drawable)
	(let * 
		(
			(anImage 0)
			(numlayers 0)
			(layers 0)
			(imgw 0)
			(imgh 0)
			(idx 0)
			(layr 0)
			(xoff 0)
			(yoff 0)
			(zx 0)
			(zxs 0)
			(zy 0)
			(zys 0)
			(counter 0)
			(temp 0)
			(temp2 0)
		)

		(set! anImage   (car (gimp-image-duplicate img)))
		(set! numlayers (car (gimp-image-get-layers anImage)))
		(set! layers    (cadr(gimp-image-get-layers anImage)))
		(set! imgw      (car (gimp-image-width anImage)))
		(set! imgh      (car (gimp-image-height anImage)))
		(while (< counter imgh)
			(set! temp (+ temp imgw))
			(set! counter (+ counter 1))
		)
		(set! counter 0)
		(while (< counter numlayers)
			(set! temp2 (+ temp2 temp))
			(set! counter (+ counter 1))
		)
		(set! temp2 (sqrt temp2))
		(set! zxs      	(ceiling (/ temp2 imgw)))
		(set! zys   	(ceiling (/ temp2 imgh)))
		;(if (< zys zxs)
		;	(set! temp zxs)
		;	(set! zxs zys)
		;	(set! zys temp)
		;)
		(set! zxs      	(ceiling zxs))
		(set! zys   	(ceiling zys))
		(while (and (< zy zys) (< idx numlayers))
			(while (and (< zx zxs) (< idx numlayers))
				(set! layr (aref layers (- (- numlayers 1) idx)))
				(gimp-layer-translate layr xoff yoff)
				(set! idx (+ idx 1))
				(set! zx (+ zx 1))
				(set! xoff (+ imgw xoff))
			)
			(set! xoff 0)
			(set! zx 0)
			(set! yoff (+ imgh yoff))
			(set! zy (+ zy 1))
		)
		
		(gimp-image-resize-to-layers anImage)
		(gimp-image-merge-visible-layers anImage EXPAND-AS-NECESSARY)
		(gimp-display-new anImage)
	)
	
)		
		
(script-fu-register "create-sprite-sheet"
	_"<Toolbox>/Xtns/Sprite-Sheet/Create From Layers..."
    "Creates a new image from current image, then offsets each layer of new image, and finally merges all visible layers to create a spritesheet"
    "Brian.Schultheiss@airegear.com"
    "Brian.Schultheiss@airegear.com"
    "2009"
    "INDEXED* RGB* GRAY*"
    SF-IMAGE        "Image to use"          0
    SF-DRAWABLE     "Layer to use"          0
)